<?php

namespace EventPortal\Domain\Util\Toast;

class Toast
{
    /** @var string */
    public $type;

    /** @var string */
    public $message;

    /** @var int */
    public $timeout = 5000;

    public function success(string $message): self
    {
        $this->type = 'success';
        $this->message = $message;

        return $this->flash();
    }

    public function error(string $message): self
    {
        $this->type = 'error';
        $this->message = $message;

        return $this->flash();
    }

    public function setTimeout(int $seconds): self
    {
        $this->timeout = $seconds * 1000;

        return $this;
    }

    public function neverTimeout(): self
    {
        $this->timeout = 0;

        return $this;
    }

    protected function flash(): self
    {
        session()->flash('toast', [
            'type' => $this->type,
            'message' => $this->message,
            'timeout' => $this->timeout,
        ]);

        return $this;
    }
}
